// https://github.com/gloriasoft/veaury/blob/master/webpack/VeauryVuePlugin.cjs
// 'vue-loader' => require.resolve('vue-loader')，并开启 hotReload
const { VueLoaderPlugin } = require('vue-loader');
let vueJsx = [];
try {
    require.resolve('@vue/babel-plugin-jsx');
    vueJsx.push('@vue/babel-plugin-jsx');
}
catch (e) { }
class VeauryVuePlugin {
    constructor(options = {}) {
        this.vueLoaderPluginInstance = new VueLoaderPlugin();
        this.options = { ...options };
    }
    apply(compiler) {
        var _a, _b;
        function defaultBabelInclude(filename) {
            if (filename.match(/[/\\]node_modules[\\/$]+/))
                return;
            // // default pass vue file
            if (filename.match(/\.(vue|vue\.js)$/i)) {
                return filename;
            }
            // default pass vue_app path
            if (filename.match(/[/\\]vue_app[\\/$]+/))
                return filename;
        }
        const { babelLoader } = this.options;
        const extensions = (_a = compiler.options.resolve) === null || _a === void 0 ? void 0 : _a.extensions;
        if (extensions && extensions.indexOf('.vue') < 0) {
            extensions.push('.vue');
        }
        const rules = compiler.options.module.rules;
        // find oneOf rule
        const oneOfRule = rules.find((rule) => rule.oneOf);
        // the last rule is file-loader
        const fileLoaderRule = oneOfRule && oneOfRule.oneOf[oneOfRule.oneOf.length - 1];
        if (fileLoaderRule) {
            // ignore vue type file
            (_b = fileLoaderRule.exclude) === null || _b === void 0 ? void 0 : _b.push(/\.vue$/);
        }
        const newRules = [
            {
                include: defaultBabelInclude,
                ...babelLoader,
                test: /\.(js|mjs|jsx|ts|tsx)$/,
                loader: 'babel-loader',
                options: {
                    cacheDirectory: false,
                    cacheCompression: false,
                    configFile: false,
                    babelrc: false,
                    plugins: [
                        // Compile with Vue's jsx
                        ...vueJsx,
                    ],
                },
            },
            {
                test: /\.vue$/,
                use: [{ loader: require.resolve('vue-loader'), options: { hotReload: true } }],
            },
        ];
        rules.push(...newRules);
        // apply VueLoaderPlugin
        this.vueLoaderPluginInstance.apply(compiler);
    }
}
module.exports = VeauryVuePlugin;
